/*
 * Copyright 2018 ProximaX Limited. All rights reserved.
 * Use of this source code is governed by the Apache 2.0
 * license that can be found in the LICENSE file.
 */

library xpx_chain_sdk.model.transaction;

import 'dart:math';
import 'dart:typed_data';

import 'package:base32/base32.dart';
import 'package:collection/collection.dart';
import 'package:convert/convert.dart' show hex;
import 'package:flat_buffers/flat_buffers.dart' as fb;
import 'package:sha3/sha3.dart';
import 'package:xpx_chain_sdk/src/model/transaction/schema.dart';
import 'package:xpx_chain_sdk/xpx_chain_sdk.dart';

import '../api/dto.dart';
import 'transaction/buffer/buffer.dart' as $buffer;
import 'transaction/buffer/transactions_buffer.dart' as $txn_buffer;

part 'transaction/fee_calculation_strategy.dart';
part 'transaction/abstract_transaction.dart';
part 'transaction/asset_id.dart';
part 'transaction/basic_metadata_transaction.dart';
part 'transaction/cosignature_signed_transaction.dart';
part 'transaction/deadline.dart';
part 'transaction/signed_transaction.dart';
part 'transaction/transaciton_account_properties_address.dart';
part 'transaction/transaciton_account_properties_entity_type.dart';
part 'transaction/transaciton_account_properties_mosaic.dart';
part 'transaction/transaction.dart';
part 'transaction/transaction_account_metadata.dart';
part 'transaction/transaction_aggregate.dart';
part 'transaction/transaction_alias.dart';
part 'transaction/transaction_exchange.dart';
part 'transaction/transaction_group_type.dart';
part 'transaction/transaction_ids.dart';
part 'transaction/transaction_info.dart';
part 'transaction/transaction_internal.dart';
part 'transaction/transaction_lockfund.dart';
part 'transaction/transaction_mosaic.dart';
part 'transaction/transaction_mosaic_metadata.dart';
part 'transaction/transaction_namespace_metadata.dart';
part 'transaction/transaction_multisig.dart';
part 'transaction/transaction_namespace.dart';
part 'transaction/transaction_status.dart';
part 'transaction/transaction_transfer.dart';
part 'transaction/transaction_type.dart';
